config/routes.rb
# frozen_string_literal: true

require "sidekiq/web"
require "sidekiq/cron/web"

Rails.application.routes.draw do
  mount Sidekiq::Web => "/sidekiq", :constraints => Constraints::Auth.new
  mount Yabeda::Prometheus::Exporter => "/metrics" if AppConfig.metrics

  root AppConfig.anonymous_access ? "projects#index" : "sessions#new"

  get "sign_in", to: "sessions#new"
  post "sign_in", to: "sessions#create"
  delete "logout", to: "sessions#destroy"

  resources :projects, only: %i[index create update]

  put "/jobs/:id/execute", to: "job#execute", as: "job_execute"

  namespace :api, defaults: { format: :json } do
    resources :hooks, only: [:create]
    resources :notify_release, only: [:create]
    resources :projects, only: %i[index show create update destroy]
    scope :projects do
      resources :registration, only: [:create] if AppConfig.project_registration == "system_hook"
    end
  end

  Healthcheck.routes(self)
end

app/models/project.rb
# frozen_string_literal: true

# Gitlab project
#
# @!attribute id
#   @return [Integer]
# @!attribute name
#   @return [String]
# @!attribute forked_from_id
#   @return [Integer]
# @!attribute forked_from_name
#   @return [String]
# @!attribute webhook_id
#   @return [Integer]
# @!attribute web_url
#   @return [String]
# @!attribute gitlab_access_token
#   @return [String]
# @!attribute merge_requests
#   @return [Array<MergeRequest>]
# @!attribute vulnerability_issues
#   @return [Array<VulnerabilityIssue>]
# @!attribute update_jobs
#   @return [Array<Update::Job>]
# @!attribute configuration
#   @return [Configuration]
class Project
  include Mongoid::Document

  unalias_attribute :id

  field :name, type: String
  field :id, type: Integer
  field :forked_from_id, type: Integer
  field :forked_from_name, type: String
  field :webhook_id, type: Integer
  field :web_url, type: String
  field :gitlab_access_token, type: EncryptedString

  has_many :merge_requests, dependent: :destroy
  has_many :vulnerability_issues, dependent: :destroy
  has_many :update_jobs, class_name: "Update::Job", dependent: :destroy

  embeds_one :configuration

  index({ id: 1 }, { unique: true })
  index({ name: 1 }, { unique: true })

  # All open merge requests
  #
  # @param [String] package_ecosystem
  # @param [String] directory
  # @return [Array<MergeRequest>]
  def open_merge_requests(package_ecosystem:, directory:)
    merge_requests.where(
      package_ecosystem: package_ecosystem,
      directory: directory,
      state: "opened"
    )
  end

  # Project open merge requests
  #
  # @param [String] dependency_name
  # @param [String] directory
  # @return [Array<MergeRequest>]
  def open_dependency_merge_requests(dependency_name, directory)
    merge_requests
      .where(main_dependency: dependency_name, directory: directory, state: "opened")
      .compact
  end

  # :reek:LongParameterList

  # Open superseded merge requests
  #
  # @param [String] package_ecosystem
  # @param [String] directory
  # @param [String] update_from
  # @param [Integer] mr_iid
  # @return [Array<MergeRequest>]
  def superseded_mrs(package_ecosystem:, directory:, update_from:, mr_iid:)
    merge_requests
      .where(
        update_from: update_from,
        package_ecosystem: package_ecosystem,
        directory: directory,
        state: "opened"
      )
      .not(iid: mr_iid)
      .compact
  end

  # Open vulnerability issues
  #
  # @param [String] package_ecosystem
  # @param [String] directory
  # @param [String] package
  # @return [Array<VulnerabilityIssue>]
  def open_vulnerability_issues(package_ecosystem:, directory:, package:)
    vulnerability_issues
      .where(
        directory: directory,
        package: package,
        package_ecosystem: package_ecosystem,
        status: "opened"
      )
  end

  # Return projects hash representation
  #
  # @return [Hash]
  def to_hash
    {
      id: id,
      name: name,
      forked_from_id: forked_from_id,
      forked_from_name: forked_from_name,
      webhook_id: webhook_id,
      web_url: web_url,
      config: configuration&.updates
    }
  end
end

app/controllers/api/projects_controller.rb
# frozen_string_literal: true

module Api
  class ProjectsController < ApplicationController
    # List all registered projects
    #
    # @return [String]
    def index
      json_response(body: Project.all.map(&:to_hash))
    end

    # Return single project
    #
    # @return [String]
    def show
      json_response(body: project.to_hash)
    end

    # Add new project or update existing one and schedule jobs
    #
    # @return [String]
    def create
      log(:info, "Registering project '#{project_name}'")
      project = Dependabot::Projects::Creator.call(project_name, access_token: params[:gitlab_access_token])
      return json_response(body: { status: 400, error: "Project is in archived state!" }, status: 400) unless project

      Cron::JobSync.call(project)
      json_response(body: project.to_hash)
    rescue ActionController::ParameterMissing
      json_response(body: { status: 400, error: "Missing parameter 'project'" }, status: 400)
    end

    # Update project attributes
    #
    # @return [String]
    def update
      project.update_attributes!(**params.permit(
        :name,
        :forked_from_id,
        :forked_from_name,
        :webhook_id,
        :web_url,
        :config
      ))
      json_response(body: project.to_hash)
    end

    # Remove project
    #
    # @return [String]
    def destroy
      Dependabot::Projects::Remover.call(project_id)
    end

    private

    # Find project
    #
    # @return [Project]
    def project
      @project ||= begin
        args = project_id.is_a?(Integer) ? { id: project_id } : { name: project_id }
        Project.find_by(**args)
      end
    end

    # Project name
    #
    # @return [String]
    def project_name
      @project_name ||= params.require(:project)
    end

    # Project id or full path
    #
    # @return [Integer, String]
    def project_id
      @project_id ||= begin
        id = params[:id]
        return id unless id.match?(/\d/)

        id.to_i
      end
    end
  end
end

app/controllers/projects_controller.rb
# frozen_string_literal: true

class ProjectsController < ApplicationController
  before_action :authenticate_user!

  # Render index projects page
  #
  # @return [void]
  def index
    @projects = Project.not(configuration: nil).order(name: :asc)
  end

  # Add new project
  #
  # @return [void]
  def create
    project_name = params.require(:project_name)
    access_token = params[:access_token].presence

    existing_project = Project.where(name: project_name).first
    return redirect_to(projects_path, notice: "Project already added!") if existing_project

    project = Dependabot::Projects::Creator.call(params.require(:project_name), access_token: access_token)
    return redirect_to(projects_path, notice: "No configuration in the project") unless project.configuration

    Cron::JobSync.call(project)
    redirect_to projects_path, notice: "Project added"
  rescue Gitlab::Error::Error => e
    redirect_to projects_path, alert: e.message
  end

  # Sync existing project
  #
  # @return [void]
  def update
    project = Project.find_by(id: params.require(:id))

    Dependabot::Projects::Creator.call(project.name, access_token: project.gitlab_access_token)
    Cron::JobSync.call(project)

    redirect_to projects_path
  end
end

app/views/projects/index.html.erb
<!DOCTYPE html>
<html lang="en">
  <head>
    <title>Dependabot Gitlab</title>
    <%= stylesheet_link_tag "application", "data-turbo-track": "reload" %>
  </head>

  <body>
    <a class="version" href="https://dependabot-gitlab.gitlab.io/dependabot"><%= "v#{version}"%></a>
    <%= button_to "Logout", logout_path, method: :delete, title: "Logout user" unless AppConfig.anonymous_access %>
    <h1>Projects</h1>

    <%= form_with url: projects_path, method: :post do |form| %>
      <%= form.label :project_name, "Project path to add:" %>
      <%= form.text_field :project_name %>
      <%= form.label :access_token, "Access token: (optional)" %>
      <%= form.text_field :access_token %>
      <%= form.submit "Add" %>
    <% end %>

    <% flash.each do |type, msg| %>
      <p>
        <strong><%= type %></strong>: <%= msg %>
      </p>
    <% end %>

    <% @projects.each do |project| %>
      <header>
        <h2><%= link_to_if project.web_url, project.name, project.web_url %></h2>
      </header>
      <%= button_to "Sync", project_path(project.id), method: :put, title: "Sync project configuration" %>

      <table class="blueTable">
        <thead>
          <tr>
            <th>Package ecosystem</th>
            <th>Directory</th>
            <th>Cron</th>
            <th>Last executed</th>
            <th>Last execution errors</th>
            <th>Open merge requests</th>
            <th>Actions</th>
          </tr>
        </thead>

        <tbody>
          <% project.update_jobs.each do |job| %>
            <tr>
              <td><%= job.package_ecosystem %></td>
              <td><%= job.directory %></td>
              <td><%= job.cron %></td>
              <td><%= job.last_executed&.to_formatted_s(:long) %>
              <td><%= job.runs.last&.failures&.map(&:message)&.join("\n") %></td>
              <td>
                <%=
                  mrs = open_merge_requests(project, job.package_ecosystem, job.directory).length
                  link_to_if(mrs > 0, mrs, open_mrs_url(project, job.package_ecosystem, job.directory))
                %>
              </td>
              <td>
                <%= button_to "Execute", job_execute_path(job.id), method: :put, title: "Execute job now" %>
              </td>
            </tr>
          <% end %>
        </tbody>
      </table>
    <% end %>
  </body>
</html>